package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:阿森斯失眠量表
 * @date 2021/7/20 15:55
 */
public class AISScale extends BaseScale{

    public AISScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {
        //得分
        int score = 0;
        JSONObject jsonObject0 = jsonArray.getJSONObject(0);
        if (jsonObject0.getString("checkItems").equals("轻微延迟")) {
            score += 1;
        } else if (jsonObject0.getString("checkItems").equals("显著延迟")) {
            score += 2;
        } else if (jsonObject0.getString("checkItems").equals("延迟严重或没有睡觉")) {
            score += 3;
        }
        JSONObject jsonObject1 = jsonArray.getJSONObject(1);
        if (jsonObject1.getString("checkItems").equals("轻微影响")) {
            score += 1;
        } else if (jsonObject1.getString("checkItems").equals("显著影响")) {
            score += 2;
        } else if (jsonObject1.getString("checkItems").equals("严重影响或没有睡觉")) {
            score += 3;
        }
        JSONObject jsonObject2 = jsonArray.getJSONObject(2);
        if (jsonObject2.getString("checkItems").equals("轻微提早")) {
            score += 1;
        } else if (jsonObject2.getString("checkItems").equals("显著提早")) {
            score += 2;
        } else if (jsonObject2.getString("checkItems").equals("严重提早或没有睡觉")) {
            score += 3;
        }
        JSONObject jsonObject3 = jsonArray.getJSONObject(3);
        if (jsonObject3.getString("checkItems").equals("轻微不足")) {
            score += 1;
        } else if (jsonObject3.getString("checkItems").equals("显著不足")) {
            score += 2;
        } else if (jsonObject3.getString("checkItems").equals("严重不足或没有睡觉")) {
            score += 3;
        }
        JSONObject jsonObject4 = jsonArray.getJSONObject(4);
        if (jsonObject4.getString("checkItems").equals("轻微不满")) {
            score += 1;
        } else if (jsonObject4.getString("checkItems").equals("显著不满")) {
            score += 2;
        } else if (jsonObject4.getString("checkItems").equals("严重不满或没有睡觉")) {
            score += 3;
        }
        JSONObject jsonObject5 = jsonArray.getJSONObject(5);
        if (jsonObject5.getString("checkItems").equals("轻微低落")) {
            score += 1;
        } else if (jsonObject5.getString("checkItems").equals("显著低落")) {
            score += 2;
        } else if (jsonObject5.getString("checkItems").equals("严重低落")) {
            score += 3;
        }
        JSONObject jsonObject6 = jsonArray.getJSONObject(6);
        if (jsonObject6.getString("checkItems").equals("轻微影响")) {
            score += 1;
        } else if (jsonObject6.getString("checkItems").equals("显著影响")) {
            score += 2;
        } else if (jsonObject6.getString("checkItems").equals("严重影响")) {
            score += 3;
        }
        JSONObject jsonObject7 = jsonArray.getJSONObject(7);
        if (jsonObject7.getString("checkItems").equals("轻微思睡")) {
            score += 1;
        } else if (jsonObject7.getString("checkItems").equals("显著思睡")) {
            score += 2;
        } else if (jsonObject7.getString("checkItems").equals("严重思睡")) {
            score += 3;
        }

        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));
        if (score < 4){
            resultMap.put("结论", "无睡眠障碍");
            resultJson.put("结论", "无睡眠障碍");
        }else if (score >= 4 && score <= 6){
            resultMap.put("结论", "可疑失眠");
            resultJson.put("结论", "可疑失眠");
        }else {
            resultMap.put("结论", "失眠");
            resultJson.put("结论", "失眠");
        }

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",Constant.SHEET_NAME_AIS);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
